# SwaggerClient-php
This is the API behind the APIs.io search engine.

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: V1
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/git_user_id/git_repo_id.git"
    }
  ],
  "require": {
    "git_user_id/git_repo_id": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: api_key
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('x-api-key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('x-api-key', 'Bearer');

$apiInstance = new Swagger\Client\Api\SearchApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\APIsJSON(); // \Swagger\Client\Model\APIsJSON | 

try {
    $result = $apiInstance->addAPI($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling SearchApi->addAPI: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\Api\SearchApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$search = "search_example"; // string | Keyword to search by.
$type = "type_example"; // string | Type to search by.
$maintainer = "maintainer_example"; // string | Maintainer to search by.
$limit = "limit_example"; // string | 
$page = "page_example"; // string | 

try {
    $result = $apiInstance->searchAPIs($search, $type, $maintainer, $limit, $page);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling SearchApi->searchAPIs: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\Api\SearchApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$search = "search_example"; // string | Keyword to search by.
$limit = "limit_example"; // string | 
$page = "page_example"; // string | 

try {
    $result = $apiInstance->searchMaintainers($search, $limit, $page);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling SearchApi->searchMaintainers: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SearchApi* | [**addAPI**](docs/Api/SearchApi.md#addapi) | **POST** /search/apis | Submit API
*SearchApi* | [**searchAPIs**](docs/Api/SearchApi.md#searchapis) | **GET** /search/apis | Search APIs
*SearchApi* | [**searchMaintainers**](docs/Api/SearchApi.md#searchmaintainers) | **GET** /search/maintainers | Search Maintainers

## Documentation For Models

 - [API](docs/Model/API.md)
 - [APIsJSON](docs/Model/APIsJSON.md)
 - [AnyOfSearchDataItems](docs/Model/AnyOfSearchDataItems.md)
 - [Contact](docs/Model/Contact.md)
 - [DiagnosticSeverity](docs/Model/DiagnosticSeverity.md)
 - [Format](docs/Model/Format.md)
 - [Formats](docs/Model/Formats.md)
 - [Given](docs/Model/Given.md)
 - [HumanReadableSeverity](docs/Model/HumanReadableSeverity.md)
 - [Latest](docs/Model/Latest.md)
 - [LatestProperties](docs/Model/LatestProperties.md)
 - [LatestPropertiesRules](docs/Model/LatestPropertiesRules.md)
 - [LatestRules](docs/Model/LatestRules.md)
 - [Maintainer](docs/Model/Maintainer.md)
 - [MetaInformation](docs/Model/MetaInformation.md)
 - [ModelInclude](docs/Model/ModelInclude.md)
 - [PathExpression](docs/Model/PathExpression.md)
 - [Property](docs/Model/Property.md)
 - [PublishAPIs](docs/Model/PublishAPIs.md)
 - [PublishMaintainers](docs/Model/PublishMaintainers.md)
 - [PublishProperties](docs/Model/PublishProperties.md)
 - [PublishTags](docs/Model/PublishTags.md)
 - [Rule](docs/Model/Rule.md)
 - [Search](docs/Model/Search.md)
 - [SearchLinks](docs/Model/SearchLinks.md)
 - [SearchMeta](docs/Model/SearchMeta.md)
 - [Severity](docs/Model/Severity.md)
 - [Tag](docs/Model/Tag.md)
 - [Then](docs/Model/Then.md)
 - [UpdateMaintainers](docs/Model/UpdateMaintainers.md)
 - [UpdateProperties](docs/Model/UpdateProperties.md)
 - [UpdateTags](docs/Model/UpdateTags.md)

## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

info@apievangelist.com

